

#Set up balloon help
global config
option add *Balloonhelp*background white widgetDefault
option add *Balloonhelp*foreground black widgetDefault
option add *Balloonhelpinfo.wrapLength 3i  widgetDefault
option add *Balloonhelp.info.justify left widgetDefault
#set ColorSpecs(BalloonHelp,Background) \#FA4
#set ColorSpecs(BalloonHelp,Foreground) black
#set ColorSpecs(Default,Background) \#FFD8B1

toplevel .balloonhelp \
    -class Balloonhelp \
    -background black \
    -borderwidth 1 \
    -relief flat
#label .balloonhelp.arrow -anchor nw -bitmap @arrow.xbm
#pack .balloonhelp.arrow -side left -fill y
label .balloonhelp.info \
    -font BalloonHelpFont \
    -bg $config(gui,color_balloonHelp_bg) \
    -fg $config(gui,color_balloonHelp_fg)
pack .balloonhelp.info -side left -fill y
wm overrideredirect .balloonhelp 1
wm withdraw .balloonhelp
.balloonhelp.info configure -text ""

#set config(balloonhelp) 1
array set OverlapP {}

# This function returns the x & y boundries of the display that the mouse
# is in at the moment.  It uses the glob(displays) list to do its magic.
# Return is a list: {minx maxx miny maxy}
proc FindWindowBoundries { } {
  global glob
  set mx [winfo pointerx .]
  set my [winfo pointery .]
  if {! [info exists glob(displays)] } {
    set glob(displays) [getDisplays]
  }
  foreach disp $glob(displays) {
    if {$mx > [lindex $disp 0] && \
	    $mx < [lindex $disp 1] && \
	    $my > [lindex $disp 2] && \
	    $my < [lindex $disp 3] } {
      return $disp
    }
  }
  return "0 0 0 0"
}
proc balloonhelp_for {win mesg} {
    global bhInfo
    set ::bhOverlapP($win) 1; 
    set bhInfo($win) $mesg
    bind $win <Enter> {+balloonhelp_pending %W}
    bind $win <Leave> {+balloonhelp_cancel}
}

proc balloonhelpd_for {win mesg} {
    global bhInfo
    set ::bhOverlapP($win,d) 0;
    set bhInfo($win,d) $mesg
    bind $win <Enter> {+balloonhelp_show %W 1}
    bind $win <Leave> {+wm withdraw .balloonhelp;\
			   .balloonhelp.info configure -text ""}
}

proc balloonhelp_pending {win} {
     global bhInfo
     balloonhelp_cancel
    if {[info exist bhInfo($win,d)]} {
	set PendTime 2000;
    } else {
	set PendTime 1000;
    }
    set bhInfo(pending) [after $PendTime [list balloonhelp_show $win 0]]
}

proc balloonhelp_cancel {} {
    global bhInfo
    if { [info exists bhInfo(pending)]} {
	after cancel $bhInfo(pending)
	unset bhInfo(pending)
    }
    wm withdraw .balloonhelp
    .balloonhelp.info configure -text ""
}

proc balloonhelp_show {win d} {
  global config bhInfo
  global bhOverlapP;  

  if {[winfo exists $win]} {
    if {$config(balloonhelp)} {
      if {$d} {
	set Text $bhInfo($win,d)
      } else {
	set Text $bhInfo($win)
      }
#      puts "$Text"
      if { [string range $Text 0 1] == "\[_" } {
	set Text [eval concat $Text]
      }
      .balloonhelp.info configure -text $Text;
      # Need the update to allow the wm to do its thing... before we ask
      # how big the window is/will be.
      set mx [expr {[winfo pointerx .] + 5}]
      set my [expr {[winfo pointery .] +5}]
      #
      # Least I forget, on of the window managers does not actually size the 
      # window until it is up, thus we rasie it and then move it if needed.
      # (May cause a slight flash of the first position (below and left of ptr.)
      #
      wm geometry .balloonhelp +$mx+$my
      set Boundries [FindWindowBoundries]
      wm deiconify .balloonhelp
      raise .balloonhelp
      update
      set sz "[regsub -all {[x+]} [wm geometry .balloonhelp] { }]"
 #     puts "$sz"
      set MaxStringWidth [lindex $sz 0]
      set MaxHeight [lindex $sz 1]
#      puts "$Boundries $mx $my"
      if {$mx + $MaxStringWidth > [lindex $Boundries 1] } {
	set mx [expr {$mx - $MaxStringWidth -10}]
      }
      if {$my + $MaxHeight > [lindex $Boundries 3] } {
	set my [expr {$my - $MaxHeight -10} ]
      }
      wm geometry .balloonhelp +$mx+$my
    }
  }
  if {[info exist bhInfo(pending)]} {
    unset bhInfo(pending)
  }
}

#if 0
#proc ControlBalloonHelp {} {
#    if {$::BalloonHelpToggle} {
#	balloonhelp_control 1
#    } else {
#	balloonhelp_control 0
#    }
#}

#set BalloonHelpToggle 1
#ControlBalloonHelp;
#endif