
# This dialog got rather large and ugly so it got a file of its own
# I know it can be made shorter with smarter logic, but since it works...


proc ChmodDialog { filename mode } {
  global glob config chmod_state chmod_orig \
      chmod_action chmod_recurse chmod_cancel

  set chmod_cancel 0
  set w .chmod_dialog
  toplevel $w -class Dialog
  wm title $w "Change permission flags"
  wm iconname $w "Change permission flags"
  wm resizable $w false false
  wm transient $w [winfo toplevel [winfo parent $w]]

  # To make the loops work better, for special we use read=setuid, write=setgid
  # and exec=sticky

  set i 0
  foreach ogus {other group user special} {
    foreach xwr {exec write read} {
      set chmod_orig($ogus,$xwr) [expr {($mode >> $i) & 1}]
      incr i
    }
  }

  ChmodSetSet 

  frame $w.top
  label $w.top.filename -text $filename -bg white
  pack $w.top.filename -side top -expand 1 -fill x -pady 4

  frame $w.mid

  foreach ugos {user group other special} Ugos {User Group Other Special} {
    frame $w.mid.$ugos
    label $w.mid.$ugos.title -text $Ugos
    pack $w.mid.$ugos.title -side top -anchor w
    foreach rwx {read write exec} sss {setuid setgid sticky} {
      checkbutton $w.mid.$ugos.$rwx  \
	  -text [expr {$ugos == "special" ? $sss : $rwx} ] \
	  -variable  chmod_state($ugos,$rwx)
      pack $w.mid.$ugos.$rwx -side top -anchor w
    }
    pack $w.mid.$ugos -side left
  }
  frame $w.bot
  frame $w.bot.action
  label $w.bot.action.title -text Action
  pack $w.bot.action.title -side top -anchor w
  foreach sad {set add del} Sad {Set Add Del} {
    radiobutton $w.bot.action.$sad -text $Sad \
	-variable chmod_action -value $sad -command ChmodSet$Sad
    pack $w.bot.action.$sad -side top -anchor w
  }
  checkbutton $w.bot.action.recurse  -text Recurse -variable chmod_recurse
  pack $w.bot.action.recurse -side top -anchor w

  button $w.bot.ok -text Ok -command "set chmod_cancel 0; destroy $w"
  button $w.bot.cancel -text Cancel -command "set chmod_cancel 1; destroy $w"

  pack $w.bot.cancel -side right -anchor s 
  pack $w.bot.ok -side right -anchor s 

  pack $w.bot.action -side left
  pack $w.top -side top -expand 1 -fill x
  pack $w.mid -side top
  pack $w.bot -side top -expand 1 -fill x

  $w.bot.action.set select

  wm withdraw $w
  update idletasks
  set pw [winfo parent $w]
  set x [expr [winfo width $pw]/2 - [winfo reqwidth $w]/2 \
	     + [winfo x $pw]]
  set y [expr [winfo height $pw]/2 - [winfo reqheight $w]/2 \
	     + [winfo y $pw]]
  wm geom $w +$x+$y
  wm deiconify $w

  set oldGrab [grab current $w]
  frgrab $w
  set oldena $glob(enableautoupdate)
  set glob(enableautoupdate) 0
  tkwait window $w
  if {$oldGrab != ""} {
    frgrab $oldGrab
  }

  # calc chmod arguments
  set chmod_arg ""
  if {$chmod_action == "set" } {
    set chmod_arg 0
    set i 0
    foreach ogus {other group user special} {
      foreach xwr {exec write read} {
	set chmod_arg [expr {$chmod_arg | $chmod_state($ogus,$xwr) << $i}]
	incr i
      }
    }
    set chmod_arg [format {%o} $chmod_arg]
  } else {
    set pm [expr {$chmod_action == "add" ? "+" : "-"}]
    set user ""
    set group ""
    set other ""
    set all ""
    set arg ""
    foreach ugo {user group other} {
      foreach rwx {read write exec} srwx {r w x} {
	if {$chmod_state($ugo,$rwx)} {set $ugo "$srwx[set $ugo]"}
      }
    }
    if {$chmod_state(special,read)} {set user "s$user"}
    if {$chmod_state(special,write)} {set group "s$group"}
    if {$chmod_state(special,exec)} {set all "t$all"}

    foreach ugo {user group other} s {u g o} {
      if {[set $ugo] != ""} {
	if {$arg != ""} { set arg ",$arg" }
	set arg "$s$pm[set $ugo]$arg"
      }
    }
    if {$all != ""} {
      if {$arg != ""} { set arg ",$arg" }
      set arg "a$pm$all$arg"
    }
    set chmod_arg $arg
  }
  if {$chmod_recurse} {
    set chmod_arg "-R $chmod_arg"
  }
  
  set glob(enableautoupdate) $oldena
  if {$chmod_cancel} {set chmod_arg ""}
  unset chmod_state chmod_orig chmod_action chmod_recurse chmod_cancel
  puts "$chmod_arg"
  return $chmod_arg
}

proc ChmodSetAdd { } {
  global chmod_state chmod_orig
  foreach i [array names chmod_orig] {
    set chmod_state($i) 0
  }
}

proc ChmodSetDel { } {
  global chmod_state chmod_orig
  foreach i [array names chmod_orig] {
    set chmod_state($i) 0
  }
}

proc ChmodSetSet { } {
  global chmod_state chmod_orig
  foreach i [array names chmod_orig] {
    set chmod_state($i) $chmod_orig($i)
  }
}

proc GetStringFromMode { mode } {
  global glob
  if { $glob(os) == "WIN32" } {
    return [format "0x%x" $mode]
  }
  return [format "%s%s%s%s%s%s%s%s%s" \
	      [expr {$mode &  00400 ? "r" : "-"}] \
	      [expr {$mode &  00200 ? "w" : "-"}] \
	      [expr {$mode & 0004000 ? "S" : \
			 [expr {$mode & 00100 ? "x" : "-"}]}\
		  ] \
	      [expr {$mode & 00040 ? "r" : "-"}] \
	      [expr {$mode & 00020 ? "w" : "-"}] \
	      [expr {$mode & 0002000 ? "S" : \
			 [expr {$mode & 00010 ? "x" : "-"}]}\
		  ] \
	      [expr {$mode &  00004 ? "r" : "-"}] \
	      [expr {$mode & 00002 ? "w" : "-"}] \
	      [expr {$mode & 0001000 ? "T" : \
			 [expr {$mode & 00001 ? "x" : "-"}]}\
		  ]\
	     ]
}

# And now the invers, get mode from string (for our FTP friends)

proc GetModeFromString { st } {
  # Sting should be 9 chars.  We start from the right and use the 
  # least 9. We ignor characters that are not in the right place...

  incr result 0
  incr count 0
  foreach gr {0o1 0o10 0o100 } sp {0o1000 0o2000 0o4000} {
    foreach ur [list $gr [expr {$gr * 2}] [expr {$gr *4}] ] exp { "x" "w" "r" } {
      set ch [string index $st end-$count]
      set special [expr {$count == 0 ? "T" : "S"}]
      incr count
      if { $ch == $exp } {set result [expr {$result | $ur}]}
      if { $exp == "x" && $ch == $special} {set result [expr {$result | $sp} ] }
    }
  }
  return [format  "%05o" $result]
}
