set ftp(procs) [info procs FTP\[a-z\]* ]

# --------- API commands 
proc FTP_OpenSession { ftpI sftp host_and_port user password realhost init} {
  global ftp glob config
  frputs "ftpI" "sftp" "host_and_port" "user" "password" "realhost" "init"
  set ftp($ftpI,sftp) $sftp

  # This is here to allow users to write there own xFTP code and have it
  # linked to filerunner on the fly.
  set found 0
  if {[info procs $ftp($ftpI,sftp)FTPopen] == ""} {
    foreach dir "$glob(conf_dir) $glob(lib_fr)/Makefiles $glob(lib_fr)" {
      frputs "looking for $dir/$ftp($ftpI,sftp)ftp.tcl "
      if {[file exist $dir/$ftp($ftpI,sftp)ftp.tcl]} {
	frputs "sourcing  $dir/$ftp($ftpI,sftp)ftp.tcl "
	source $dir/$ftp($ftpI,sftp)ftp.tcl
	if {[info procs $ftp($ftpI,sftp)FTPopen] == ""} {continue}
	set found 1
	break
      }
    }
  } else {
    set found 1
  }
  if { ! $found} {
    PopWarn "Could not find $ftp($ftpI,sftp)ftp.tcl\n \
            looked in these dirs:\n \
            $glob(conf_dir) $glob(lib_fr)/Makefiles $glob(lib_fr) \
            \n\n Aborting $ftp($ftpI,sftp)ftp connection."
    return -code error "$ftp($ftpI,sftp)ftp.tcl not found"
  }
  foreach proc $ftp(procs) {
    if {[info procs $ftp($ftpI,sftp)$proc] == "" } {
      lappend notfound $ftp($ftpI,sftp)$proc
    }
  }
  if {[info exists notfound]} {
    PopWarn "Could not find procs: $notfound \n\n \
             Aborting $ftp($ftpI,sftp) connection."
    return -code error "Required functions not found in $ftp($ftpI,sftp)ftp.tcl"
  }	  
  set ftp($ftpI,debug) $glob(ftp,debug)
  set ftp($ftpI,realhost) $realhost
  set ftp($ftpI,user) $user
  set ftp($ftpI,password) $password
  set ftp($ftpI,pwd) ""
  set ftp($ftpI,new_wd) ""
  set ftp($ftpI,resume) 0
  set ftp($ftpI,init_cmd) $init
  set ftp($ftpI,ignorError) 0
  set ftp($ftpI,start_time) {}
  if { [info exists ftp(server1)] == 0 } {
    set ftp(server1) ""
  }
  if { [info exists ftp(server2)] == 0 } {
    set ftp(server2) ""
  }
  set r [regexp {([^:]+)(:([0-9]+))?} $host_and_port match ftp($ftpI,host) dummy ftp($ftpI,port)]
  if {!$r} {
    FTP_Error $ftpI "Malformed (s)FTP URL $host_and_port.\
                    Format: site:port ex: ftp.foo.bar:21"
  }
  if {$ftp($ftpI,port) == ""} {
    if {$sftp == "" } {
      set ftp($ftpI,port) 21
    } else {
      set ftp($ftpI,port) 22
    }
  }
  if { $ftp($ftpI,debug) } {
    puts "--$ftp($ftpI,init_cmd) --$ftp($ftpI,realhost) --$init"
    puts " realhost  $ftp($ftpI,realhost) \
	   \nuser	 $ftp($ftpI,user) \
	   \npassword   $ftp($ftpI,user)\
	   \nport	 $ftp($ftpI,port)\
	   \nmode passive\
	   \nprogress FTP_Progress $ftpI \
	   \ntimeout $config(ftp,timeout)\
	   \noutput FTP_Package_Error $ftpI"

    set ::ftp::DEBUG 1
    set ::ftp::VERBOSE 1

  }
  FTP_OpenLink $ftpI
  return
}

proc FTP_OpenLink {ftpI} {
  global ftp config
    set ftp($ftpI,timeout)  $config(ftp,timeout)
    set ftp($ftpI,handle) -1
    $ftp($ftpI,sftp)FTPopen \
	$ftpI \
	$ftp($ftpI,realhost) \
	$ftp($ftpI,user) \
	$ftp($ftpI,password)\
	$ftp($ftpI,port)\
	$config(ftp,timeout)\
	"FTP_Progress $ftpI" \
	"FTP_Package_Error $ftpI"	   
  set ftp($ftpI,start_time) {}
  if {$ftp($ftpI,handle) == -1 } {
    set ftp($ftpI,handle) ""
    set ftp($ftpI,state) "opening"
    FTP_Error $ftpI "Error Connecting"
    return 
  }
#  if {$ftp($ftpI,init_cmd) != ""} {
#    set ftp($ftpI,state) "ftp::Quote"
#    eval {::ftp::Quote $ftp($ftpI,init_cmd)}
#  }
}

proc FTP_StartClock {ftpI} {
  global ftp
  set ftp($ftpI,t_one) [ClockMilliSeconds]
  set size 0
  if {$ftp($ftpI,resume)} {
    set size $ftp($ftpI,resume,pos)
  }
  set ftp($ftpI,start_time) [clock seconds]
  set ftp($ftpI,tl) {}
  for {set i 0} {$i < 30} {incr i} {
    lappend tl {0 -1}
  }
  set ftp($ftpI,oldicon) [wm iconname .]
  wm iconname . "? ? [file tail $ftp($ftpI,to_fname)]"
}

proc FTP_StopClock {ftpI {get 0}} {
  global ftp
  if {[set start_time $ftp($ftpI,start_time)] == {} } return

  wm iconname . $ftp($ftpI,oldicon)
  
  set end_time [clock seconds]
  # This assumes success !! ?
  set size $ftp($ftpI,expected_size)
  if {$end_time == $start_time} {
    set total_speed "? kB/s"
  } else {
    if {$ftp($ftpI,resume)} {
      set total_speed "[format "%.2f"\
          [expr {($size - $ftp($ftpI,resume,pos)) / \
           1024.0 / ($end_time - $start_time)}]] kB/s"
    } else {
      set total_speed "[format "%.2f"\
          [expr {$size / 1024.0 / ($end_time - $start_time)}]] kB/s"
    }
  }
  set ftp($ftpI,start_time) {}
  LogStatusOnly "Transfer [file tail $ftp($ftpI,to_fname)] :\
                 $size bytes -- done ($total_speed)"
  if {$get == "abort" } return
  if {! $get} {
    LogSilent "Transfer ftp://$ftp($ftpI,realhost)$ftp($ftpI,from_fname)\
               -> $ftp($ftpI,to_fname): $size bytes -- done ($total_speed)"
  } else {
    LogSilent "Transfer $ftp($ftpI,from_fname)\
               -> ftp://$ftp($ftpI,realhost)$ftp($ftpI,to_fname):\
               $size bytes -- done ($total_speed)"
  }
  if {$get && [Try {set s [file size $ftp($ftpI,to_fname)] } "" 1] == 0 } {
    if {$ftp($ftpI,expected_size) > 0 && ($s != $ftp($ftpI,expected_size) ||\
        $s != $size) } {
      PopWarn "Warning: Files ftp://$ftp($ftpI,realhost)$ftp($ftpI,to_fname),\
               $ftp($ftpI,from_fname) are not the same size"
    }
  }
}

proc FTP_Abort {ftpI} {
  # To abort a file transfer...
  global ftp
  if {$ftp($ftpI,sftp) == "s"} {
    $ftp($ftpI,sftp)FTPabort $ftpI
  } else {
    ::ftp::Quote  ABORT
  }
  FTP_StopClock $ftpI abort
}

proc FTP_Progress {ftpI sofar} {
  global ftp config glob
  set chunksize 4096
  set timesum 0.0
  set bytesum 0
  set timenum 0
  set t_two [ClockMilliSeconds]
  set t [expr $t_two - $ftp($ftpI,t_one)]
  if {$t < 0} {
    set t 0
  }
  set ftp($ftpI,t_one) $t_two
  lappend ftp($ftpI,tl) [list $t $chunksize]
  foreach tli $ftp($ftpI,tl) {
    set timesum [expr $timesum + [lindex $tli 0]]
    incr bytesum [lindex $tli 1]
    incr timenum
  }
  if { $timesum <= 0.0 } { set timesum 1 }
  set speed [format "%.2f" [expr ($bytesum / ($timesum / 1000.0)) / 1024.0]]
  set speed_Bps [expr ($bytesum / ($timesum / 1000.0))]
  set eta "?"
  set eta_abs "?"
  if {$speed_Bps > 0} {
    set tmp [format "%.0f" [expr ($ftp($ftpI,expected_size) - $bytesum) / $speed_Bps]]
    if { $tmp >= 0 } { 
      set eta [format "%02d:%02d" [expr $tmp / 60] [expr $tmp % 60]] 
      if { $config(dateformat) == "yymmdd" } {
	set tmp_date "%y%m%d "
      } else {
	set tmp_date "%y%m%d "
      } 
      set tmp_s [clock seconds]
      if { [clock format [expr $tmp_s + $tmp] -format "%y%m%d"] ==\
	       [clock format $tmp_s -format "%y%m%d"] } {
	set tmp_date ""
      }
      set eta_abs [clock format [expr $tmp_s + $tmp] -format "$tmp_date%R"]
    }
  }
  if {$ftp($ftpI,expected_size) > 0} {
    LogStatusOnly "Transfer [file tail $ftp($ftpI,to_fname)] :\
                    $bytesum / $ftp($ftpI,expected_size) bytes\
                    ($speed kB/s, ETA $eta $eta_abs)"
  } else {
    LogStatusOnly "Transfer [file tail $ftp($ftpI,to_fname)] :\
                     $bytesum bytes ($speed kB/s)"
  }
  wm iconname . "$eta $eta_abs [file tail $ftp($ftpI,to_fname)]"
  update idletasks
  if { $glob(abortcmd) } {
    FTP_Abort $ftpI
  }
  return
}

proc FTP_Package_Error {ftpI id mess state} {
  global ftp
  if {$state == "error" && $mess == "Not connected!" } {
    if { $ftp($ftpI,handle) == "" } return
    if { $ftp($ftpI,state) == "LinkCheck" } {
      LogStatusOnly "Link Check failed, reopening link to $ftpI"
      FTP_OpenLink $ftpI
      return
    }
    FTP_Error $ftpI $mess
  }
  if { $ftp($ftpI,debug) } {
    puts "state >$state <$ftpI handle $id mess >$mess < "
  }
  if {$state == "error" && !$ftp($ftpI,ignorError)} {
    FTP_Warn $ftpI $mess
    return
  }  
}


proc FTP_MakeSureLinkIsUp { ftpI } {
  # Can only be called after FTP_OpenSession has been called 
  global ftp
  if {$ftp($ftpI,handle) == "" } {
    error "$ftpI has not been opened yet"
    return
  }
  $ftp($ftpI,sftp)FTPpwd $ftpI
}

proc FTP_TrimDir { dir } {
  while { [string range $dir 0 1] == "//" } {
    set dir [string range $dir 1 end]
  }
  set dir [string trimright $dir /]
  if { $dir == "" } { set dir / }
  if { [string index $dir 0] == "/" } {
    while { 1 } {
      set len [string length $dir]
      if { [string range $dir [expr $len - 3] end] == "/.." } {
        set dir [file dirname [file dirname $dir]]
      } else {
        break
      }
    }
  }
  return $dir
}

proc FTP_CD { ftpI new_wd } {
  global ftp
  if {$new_wd == "" } { set new_wd "/" }
  if {[string index $new_wd 0] != "/"} {
    FTP_Error $ftpI "Internal error: FTP_CD can only\
                 be called with an absolute path.($new_wd)"
  }
  FTP_MakeSureLinkIsUp $ftpI
  set new_wd [FTP_TrimDir $new_wd]
  if { $new_wd == $ftp($ftpI,pwd) } {
    return 1
  }
  set ftp($ftpI,state) "cd"
  set ftp($ftpI,new_wd) $new_wd
  set result [$ftp($ftpI,sftp)FTPcd $ftpI $new_wd]
  if {$result} {
    set ftp($ftpI,pwd) $new_wd
  }
  return $result
}

proc FTP_Rename { ftpI oldname newname } {
  global ftp
  FTP_MakeSureLinkIsUp $ftpI
  set ftp($ftpI,rename,oldname) $oldname
  set ftp($ftpI,rename,newname) $newname
  set ftp($ftpI,state) "rename"
  $ftp($ftpI,sftp)FTPrename $ftpI $oldname $newname
  FTP_InvalidateCache $ftpI $oldname
}

proc FTP_Delete { ftpI filename } {
  global ftp
  FTP_MakeSureLinkIsUp $ftpI
  set ftp($ftpI,delete,filename) $filename
  set ftp($ftpI,state) "delete"
  $ftp($ftpI,sftp)FTPdelete $ftpI $filename
  FTP_InvalidateCache $ftpI $filename
}

proc FTP_MkDir { ftpI dir } {
  global ftp
  FTP_MakeSureLinkIsUp $ftpI
  set ftp($ftpI,state) "mkdir"
  $ftp($ftpI,sftp)FTPmkdir $ftpI $dir
  FTP_InvalidateCache $ftpI $dir
}

proc FTP_RmDir { ftpI dir } {
  global ftp
  FTP_MakeSureLinkIsUp $ftpI
  set ftp($ftpI,state) "rmdir"
  $ftp($ftpI,sftp)FTPrmdir $ftpI $dir
  FTP_InvalidateCache $ftpI $dir
}

proc FTP_IsDir { ftpI new_wd } {
  global ftp
  FTP_MakeSureLinkIsUp $ftpI
  set new_wd [FTP_TrimDir $new_wd]
  set ftp($ftpI,new_wd) $new_wd
  set ftp($ftpI,ignorError) 1
  set ftp($ftpI,state) "cd"
  if { [catch "$ftp($ftpI,sftp)FTPcd $ftpI $new_wd" out]} {
    if {[string match {*timed out*} $out] } {
      return -code error $out
    }
    return 0
  }
  set ftp($ftpI,pwd) $new_wd
  return 1
}

proc FTP_PWD { ftpI } {
  global ftp
  FTP_MakeSureLinkIsUp $ftpI
  set ftp($ftpI,state) "pwd"
  return [$ftp($ftpI,sftp)FTPpwd $ftpI]
}

proc FTP_Chmod { ftpI mode file} {
  global ftp
  FTP_MakeSureLinkIsUp $ftpI
  FTP_InvalidateCache $ftpI $file
  return [$ftp($ftpI,sftp)FTPchmod $ftpI $mode $file]
}

proc FTP_CloseSession { ftpI } {
  global ftp
  FTP_ShutDown $ftpI
  return
}

proc FTP_List { ftpI showall } {
  global ftp
  FTP_MakeSureLinkIsUp $ftpI
  LogStatusOnly "Reading ftp directory $ftp($ftpI,realhost)$ftp($ftpI,pwd)"
  set cache_result [FTP_ReadCache $ftp($ftpI,realhost)$ftp($ftpI,pwd)]
  if {$cache_result != ""} {
    LogStatusOnly "Reading ftp directory $ftp($ftpI,realhost)$ftp($ftpI,pwd)\
                   -- done (found in cache)"
    return $cache_result
  }
  set all [expr {$showall ? "-a" : ""}]
  set ftp($ftpI,state) "list"

  set result [$ftp($ftpI,sftp)FTPlist $ftpI $all ]

  FTP_WriteCache $ftp($ftpI,realhost)$ftp($ftpI,pwd) $result
  LogStatusOnly "Reading ftp directory $ftp($ftpI,realhost)$ftp($ftpI,pwd) -- done"
  return $result
}

proc FTP_DoSearch { ftpI filename } {
  global ftp
  FTP_MakeSureLinkIsUp $ftpI
  set ftp($ftpI,state) "ftp::Quote site EXEC LOCATE"
  set ftp($ftpI,search,name) $filename
  if {$ftp($ftpI,sftp) == "s" } {
    return -code error "sftp search is not supported...yet." 
  } else {
    return [::ftp::Quote $ftp($ftpI,handle) site EXEC LOCATE $filename]
  }
}

proc FTP_GetFile { ftpI remoteFileName localFileName expectedSize {resume 0}} {
  global ftp
  FTP_MakeSureLinkIsUp $ftpI

  if { [string range $remoteFileName 0 1] == "//" } {
    set remoteFileName [string range $remoteFileName 1 end]
  }
  if { [string range $localFileName 0 1] == "//" } {
    set localFileName [string range $localFileName 1 end]
  }
  set ftp($ftpI,expected_size) $expectedSize
  set ftp($ftpI,from_fname) $remoteFileName
  set ftp($ftpI,to_fname) $localFileName
  set ftp($ftpI,resume) 0
  set ftp($ftpI,state) "get"
  if { $resume && [file writable "$localFileName"] } {
    set r [catch {set ftp($ftpI,resume,pos) [file size "$localFileName"]}]
    set ftp($ftpI,resume) [expr !$r]
  }
  set get [expr {$ftp($ftpI,resume) ? {reget} : {get}}]
  FTP_StartClock $ftpI

  set rt [$ftp($ftpI,sftp)FTP$get $ftpI $remoteFileName $localFileName]

  FTP_StopClock $ftpI
  return $rt
}

proc FTP_PutFile { ftpI localFileName remoteFileName expectedSize } {
  global ftp
  set ftp($ftpI,expected_size) $expectedSize
  set ftp($ftpI,to_fname) $remoteFileName
  set ftp($ftpI,from_fname) $localFileName 
  set ftp($ftpI,state) "put"

  if { [string range $remoteFileName 0 1] == "//" } {
    set remoteFileName [string range $remoteFileName 1 end]
  }
  if { [string range $localFileName 0 1] == "//" } {
    set localFileName [string range $localFileName 1 end]
  }

  FTP_MakeSureLinkIsUp $ftpI
  FTP_InvalidateCache $ftpI $remoteFileName
  FTP_StartClock $ftpI
  
  set rt [$ftp($ftpI,sftp)FTPput $ftpI $localFileName $remoteFileName]

  FTP_StopClock $ftpI
  return $rt
}

proc FTP_LinkFile {ftpI exist new } {
  global ftp
  FTP_MakeSureLinkIsUp $ftpI
  set ftp($ftpI,state) "ln"

  return [$ftp($ftpI,sftp)FTPlink $ftpI $exist $new]
}

proc FTP_InvalidateCache {{ftpI ""} {file ""}} {
  global ftp
  if {$ftpI == ""} {
    set ftp(cache) ""
    if { [info exists  ftp(cacheTimeOut)]} {
      after cancel $ftp(cacheTimeOut)
      unset ftp(cacheTimeOut)
    }
    return
  }
  # If we are here it is a targeted cache delete.
  set r [FTP_ReadCache $ftp($ftpI,realhost)[file dirname $file] 1]
  frputs "Deleted " r
}

proc FTP_Error { ftpI message } {
  global ftp
  FTP_ShutDown $ftpI
  error  "$message\n\nHost: $ftp($ftpI,realhost)\nCommand: $ftp($ftpI,state)"
}

proc FTP_Warn { ftpI message } {
  global ftp
  FTP_StopClock $ftpI abort
  error "$message\n\nHost: $ftp($ftpI,realhost)\nCommand: $ftp($ftpI,state)"
}


proc FTP_ShutDown { ftpI } {
  global ftp
  if {$ftp($ftpI,handle) != -1} {
    catch "$ftp($ftpI,sftp)FTPclose $ftpI"
  }
  set ftp($ftpI,handle) ""
  set ftp($ftpI,host) ""
  set ftp($ftpI,realhost) ""
  set ftp($ftpI,user) ""
  set ftp($ftpI,password) ""
  set ftp($ftpI,state) ""
  set ftp($ftpI,pwd) ""
  set ftp($ftpI,new_wd) ""
  set ftp($ftpI,resume) 0
}


proc FTP_ReadCache { key {del 0}} {
  global ftp
  set i 0
  foreach k $ftp(cache) {
    if {[lindex $k 0] == "$key"} {
      set item $k
      set result [lindex $item 1]
      set ftp(cache) [concat [lrange $ftp(cache) 0 [expr $i - 1]]\
                     [lrange $ftp(cache) [expr $i + 1] end]]
      if { ! $del} {
	lappend ftp(cache) $item
      }
      return [lindex $item 1]
    }
    incr i
  }
  return ""
}

proc FTP_WriteCache { key data } {
  global ftp config
  set item [list $key $data]
  lappend ftp(cache) $item
  set length [llength $ftp(cache)]
  if {$length > $config(ftp,cache,maxentries)} {
    set ftp(cache) [lrange $ftp(cache) 1 end]
  }
  if { [info exists  ftp(cacheTimeOut)]} {
    after cancel $ftp(cacheTimeOut)
  }
  set ftp(cacheTimeOut) [after 60000 FTP_InvalidateCache]
}

if {$glob(debug)} {
  proc FTPlog_user {args} {log_user 1}
} else {
  proc FTPlog_user {args} {log_user 0}
}