
package require Expect

proc sFTPopen {ftpI host user password port rq_timeout args } {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  upvar #0 ftp($ftpI,timeout) timeout
#  puts "sFTP_OpenLink $ftpI $host $user $password $port $rq_timeout"
#  log_file -a EXP-LOG
  spawn -noecho sftp -P $port -p $user@$host 
  set timeout $rq_timeout
#  puts "doine expect_after"
  expect_before default \
      {set expect_out(1,string) "Connection timed out $ftpI" ;incr re }
#  puts "doing expect 1"
  log_user 0
  set re [expect "*password: " {exp_send $password\n;incr x 2} \
	  -re "Connected to.*sftp> " {incr x 0}]
#  puts "expect1 returned $re"
  if {$re == 2 } {
#    puts "doing expect 2"
    set re [expect "*password:" {incr  y }\
		-re "Connected to.*sftp> " {incr y 0}]
  }
#  puts "exiting spawn $re spawn_id $spawn_id"
  if {$re == 1} {
    catch exp_close 
    set spawn_id -1
  }
  return $spawn_id
}


proc sFTPcd {ftpI new_wd} {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  upvar #0 ftp($ftpI,timeout) timeout
#  log_user 1
#  puts "try cd to $ftp($ftpI,new_wd)"
  exp_send "cd [regsub -all {\ } $ftp($ftpI,new_wd) {\\ }]\n"
  set x 0
  expect \
      -re "\r?cd \[^\n]*\n\r?sftp> " {}\
      -re "\r?(Can't change directory\[^\n]*)\n\r?sftp> " {set x 3} \
      -re "\r?(Couldn't canonicalise\[^\n]*)\n\r?sftp> " {set x 2} 
#  puts "cd... $x"
  if {[info exists expect_out(1,string)] } { 
#    puts "cd: >$expect_out(1,string) <"
    return -code error "$expect_out(1,string)"
  }
#  puts "cd returns $x"
  return 1
}

proc sFTPrename {ftpI  old new} {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  upvar #0 ftp($ftpI,timeout) timeout
  # current name old change to new
  exp_send "rename [regsub -all {\ } $old {\\ }] \
                   [regsub -all {\ } $new {\\ }]\n"
  expect -re "(Couldn't .*)\r\nsftp>" {incr re} \
      -re ".*\r\nsftp>" {incr re 0}
  if {$re} {return -code error "$expect_out(1,string)"}
  return $re 
}

proc sFTPdelete {ftpI filename} {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  upvar #0 ftp($ftpI,timeout) timeout
  # file to remove ftp($ftpI,delete,filename)
  exp_send "rm [regsub -all {\ } $filename {\\ }]\n"
  expect -re "(Couldn't delete file: .*)\r\nsftp>" {incr re} \
      -re "Removing .*\r\nsftp>" {incr re 0}
  if {$re} {return -code error "$expect_out(1,string)"}
  return $re 
}

proc sFTPmkdir { ftpI dir } {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  upvar #0 ftp($ftpI,timeout) timeout
#  log_user 1
  # create dir ftp($ftpI,mkdir,dir)
  exp_send "mkdir [regsub -all {\ } $dir {\\ }]\n"
  expect -re "\r*(Couldn't .*)\r\nsftp>" {incr re} \
      -re ".*\r\nsftp>" {incr re 0}
  if {$re} {return -code error "$expect_out(1,string)"}
  return $re 
}

proc sFTPrmdir { ftpI dir } {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  upvar #0 ftp($ftpI,timeout) timeout
  # dir to remove is ftp($ftpI,rmdir,dir)
  exp_send "rmdir [regsub -all {\ } $dir {\\ }]\n"
  expect -re "(Couldn't remove directory: .*)\r\nsftp>" {incr re} \
      -re ".*\r\nsftp>" {incr re 0}
  if {$re} {return -code error "$expect_out(1,string)"}
  return $re
}

proc sFTPpwd { ftpI } {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  upvar #0 ftp($ftpI,timeout) timeout
#  puts "try pwd on $spawn_id"
  log_user 0
  exp_send "pwd\n"
  set re 0
  expect -re "Remote working directory: (.*)\r\nsftp> " {incr re 0} \
      -re "sftp> " {incr re 2}
  switch $re {
    0 {return $expect_out(1,string)}
    1 {return -code error "$expect_out(1,string)"}
    2 -
    default {puts "$re";return -code error "Unexpected return from pwd"}
  } 
}


proc sFTPlist { ftpI all} {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  upvar #0 ftp($ftpI,timeout) timeout
  # use -l (long list) -f (no sort) -a depends on all
  # about 12.5k entries at 80 chars each (hay, just poke around on sourceforge)
  match_max 1000000
  set cmd [expr {$all == "-a" ? "ls -alf" : "ls -lf"}]
  exp_send "$cmd\n"
  expect -ex "$cmd\r\n" {exp_continue} -re "(.*)\r\nsftp> " {incr re 0}
  if {$re}  {return -code error "$expect_out(1,string)"}
  # remove the \r chars
#  puts "$expect_out(1,string)"
  set re [regsub -all {\r} $expect_out(1,string) "" ]
#  set re [regsub -all {\n\n} $re {\n}]
#  puts  [split $re "\n"]
  match_max -d
  return [split $re "\n"] 
}

proc sFTP_DoSearch { ftpI  } {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  upvar #0 ftp($ftpI,timeout) timeout
}

proc sFTPreget { ftpI remoteFileName localFileName } {
  return [sFTPget $ftpI $remoteFileName $localFileName]
}

proc sFTPget { ftpI remoteFileName localFileName } {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  upvar #0 ftp($ftpI,timeout) timeout
#  log_user 1
  # get  remoteFileName and put it localFileName
  # use -p to get full times etc.
  set remotename [regsub -all " " $remoteFileName {\\ }]
  exp_send "get -p $remotename \
                   [regsub -all {\ } $localFileName {\\ }]\n"
  expect -re "(Couldn't .*)\r\nsftp>" {incr re} \
      -re "Fetching .*\r\n" {exp_continue} \
      -re "\r.*$remotename *(\[^ ].*:\[0-9]\[0-9])" \
          {LogStatusOnly "Transfer [file tail $remotename]\
                       $expect_out(1,string) ETA"; \
	       exp_continue} \
      -re ".*\r\nsftp>" {incr re 0}
#  log_user 0
  if {$re} {return -code error "$expect_out(1,string)"}
  return $re
}

proc sFTPput { ftpI localFileName remoteFileName } {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  upvar #0 ftp($ftpI,timeout) timeout
#  log_user 1
  puts " send $localFileName to $remoteFileName"
  set localname [regsub -all " " $localFileName {\\ }]
  exp_send "put -p  $localname  \
                   [regsub -all {\ } $remoteFileName {\\ }]\n"
  expect \
      -re "(Couldn't .*)\r\nsftp>" {incr re} \
      -re "\r*(.*Permission denied).*\r\nsftp>" {incr re} \
      -re "Uploading .*\r\n" {exp_continue} \
      -re "\r.*$localname *(\[^ ].*\[0-9]\[0-9])" \
          {LogStatusOnly "Transfer [file tail $localname]\
                       $expect_out(1,string) ETA"; exp_continue} \
      -re ".*\r\nsftp>" {incr re 0}
#  log_user 0
  if {$re && ![string match {*Couldn't fsetstat*} $expect_out(1,string)]} {
    return -code error "$expect_out(1,string)"
  }
  return $re
}

proc sFTPlink { ftpI exist new} {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  upvar #0 ftp($ftpI,timeout) timeout
  frputs "link $soft $exist $new"
  # point to this: ftp($ftpI,exist_fname) with this name ftp($ftpI,ln_fname)
  exp_send "ln -s [regsub -all {\ } $exist {\\ }] \
               [regsub -all {\ } $new {\\ }]\n"
  expect \
      -re "Permission denied\r\nsftp>" {incr re} \
      -re "Couldn't .*\r\nsftp>" {incr re} \
      -re "(.*)\r\nsftp>" {incr re 0;puts "$expect_out(1,string)" }
  if {$re} {return -code error "$expect_out(1,string)"}
   return $re
}

proc sFTPchmod {ftpI mode file} {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  upvar #0 ftp($ftpI,timeout) timeout
  log_user 1
  frputs "sFTPchmod trying " ftpI mode file
  exp_send "chmod $mode $file\n"
  expect \
      -re "(Changing mode .*)\r\nsftp>" {incr re;puts "$expect_out(1,string)"} \
      -re "(.*)\r*\nsftp>" {incr re 0;puts "$expect_out(1,string)" }
  if {$re} return ""
  return [regsub -all {\r} $expect_out(1,string) {}]
}

proc sFTPclose { ftpI} {
  global ftp
  upvar #0 ftp($ftpI,handle) spawn_id
  exp_send "quit"
  exp_close
}